> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/disk-snapshot/modifyautosnapshotpolicy.md).

# ModifyAutoSnapshotPolicy

## 1. API Description

This API (ModifyAutoSnapshotPolicy) is used to modify the basic information of the snapshot schedule.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name         | Required | Type             | Description                                                                                                                                                                                                                              |
| ---------------------- | -------- | ---------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| autoSnapshotPolicyId   | Yes      | String           | <p>ID of the snapshot schedule.</p><p>It can be obtained by calling <a href="/api-reference/zec/disk-snapshot/describeautosnapshotpolicies.md">DescribeAutoSnapshotPolicies</a>.</p>                                                     |
| autoSnapshotPolicyName | No       | String           | <p>The name of the snapshot schedule.</p><p>The length is 2 to 63 characters.</p><p>Only letters, numbers, -/\_ and periods (.) are supported.</p><p>The name must start and end with a number or a letter.</p>                          |
| repeatWeekDays         | No       | Array of Integer | <p>Repeat days of the automatic snapshots.</p><p>It is measured in days with a weekly cycle. For example, 1 indicates Monday.</p><p>Value range: \[1, 7]</p>                                                                             |
| hours                  | No       | Array of Integer | <p>Specify the trigger time of the snapshot schedule.</p><p>It uses UTC time and is measured in hours.</p><p>There are 24 time points available from 00:00 to 23:00, where 1 indicates 01:00, and so on.</p><p>Value range: \[0, 23]</p> |
| retentionDays          | No       | Integer          | <p>Retention period of the automatic snapshots, in days.</p><p>If it is set to -1, the snapshots are retained permanently.</p><p>Valid values: -1 or \[1,65535].</p>                                                                     |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Modify the attributes of a snapshot schedule, including the name and a retention period of 3 days.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyAutoSnapshotPolicy
<Common Request Params>

Request：
{
  "autoSnapshotPolicyId": "<autoSnapshotPolicyId>",
  "autoSnapshotPolicyName": "Test",
  "retentionDays": 3
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

**2. Modify only the trigger time and the retention period of a snapshot schedule: run at 03:00 every Sunday and retain snapshots permanently. Fields that are not passed remain unchanged.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyAutoSnapshotPolicy
<Common Request Params>

Request：
{
  "autoSnapshotPolicyId": "<autoSnapshotPolicyId>",
  "repeatWeekDays": [
    7
  ],
  "hours": [
    3
  ],
  "retentionDays": -1
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                  | Description                           |
| ---------------- | ------------------------------------------- | ------------------------------------- |
| 404              | INVALID\_AUTO\_SNAPSHOT\_POLICY\_NOT\_FOUND | The snapshot schedule does not exist. |
| 400              | INVALID\_RETENTION\_DAYS                    | Invalid retention days.               |
